<?php

namespace WPChill\Libs\PhpOffice\PhpSpreadsheet\Calculation\LookupRef;

use WPChill\Libs\PhpOffice\PhpSpreadsheet\Calculation\Exception;
use WPChill\Libs\PhpOffice\PhpSpreadsheet\Calculation\Information\ErrorValue;
use WPChill\Libs\PhpOffice\PhpSpreadsheet\Calculation\Information\ExcelError;

class LookupRefValidations
{
    public static function validateInt(mixed $value): int
    {
        if (!is_numeric($value)) {
            if (is_string($value) && ErrorValue::isError($value)) {
                throw new Exception($value);
            }

            throw new Exception(ExcelError::VALUE());
        }

        return (int) floor((float) $value);
    }

    public static function validatePositiveInt(mixed $value, bool $allowZero = true): int
    {
        $value = self::validateInt($value);

        if (($allowZero === false && $value <= 0) || $value < 0) {
            throw new Exception(ExcelError::VALUE());
        }

        return $value;
    }
}
