<?php

namespace WPChill\Libs\PhpOffice\PhpSpreadsheet\Writer;

use WPChill\Libs\ZipStream\Option\Archive;
use WPChill\Libs\ZipStream\ZipStream;

/**
 * Either ZipStream2 or ZipStream3, but not both, may be used.
 * For code coverage testing, it will always be ZipStream3.
 *
 * @codeCoverageIgnore
 */
class ZipStream2
{
	/**
	 * @param resource $fileHandle
	 */
	public static function newZipStream($fileHandle)
	{
		$options = new Archive();
		$options->setEnableZip64(false);
		$options->setOutputStream($fileHandle);

		return new ZipStream(null, $options);
	}
}
